'
'       MARSBASE v1.00

'       Copyright(C) 2004 by ICC Software
'
'       Republished in 2009 by Paul Wilhelm <paul@mosfetkiller.de>
'       http://mosfetkiller.de
'
'       --- HAUPTPROGRAMM ---
'
DECLARE SUB Pause ()
DECLARE SUB Story ()
DECLARE SUB Death ()
DECLARE SUB DoShot ()
DECLARE SUB Credits ()
DECLARE SUB DoLayer ()
DECLARE SUB EndProg ()
DECLARE SUB ScreenShot ()
DECLARE SUB Put.Status ()
DECLARE SUB ClearLayers ()
DECLARE SUB SaveSettings ()
DECLARE SUB LoadSettings ()
DECLARE SUB LoadGraphics ()
DECLARE SUB Instructions ()
DECLARE SUB PlaySound (Op$)
DECLARE SUB SysErr (Num%, t2$)
DECLARE SUB WarpToNextLevel ()
DECLARE SUB LoadGAT (FileName$)
DECLARE SUB SavePlayer (Player%)
DECLARE SUB LoadPlayer (Player%)
DECLARE SUB Beamto (xdif2%, ydif2%)
DECLARE SUB Put.Tiles (xdif%, ydif%)
DECLARE SUB ExploGnozz (xp%, yp%, a%)
DECLARE SUB Put.Objects (xdif%, ydif%)
DECLARE SUB ChLine (lin%, t$, FileName$)
DECLARE SUB Get.Put.PlayerName (Player%)
DECLARE SUB Put.1Tile (Layer%, x%, y%, t$)
DECLARE SUB Put.Player (Walk%, Wep%, Dir%)
DECLARE SUB DoPixelex (layer1%, layer2%, xp%, yp%)
DECLARE SUB MachineType (Layer%, kind%, y%, t$, Col%)
DECLARE SUB LoadIMG (Layer%, FileName$, xx%, yy%, xs%, ys%)
DECLARE FUNCTION SC% (L$)
DECLARE FUNCTION Menu% ()
DECLARE FUNCTION Kurz$ (a$)
DECLARE FUNCTION ChoosePlayer% ()
DECLARE FUNCTION ScanHor% (xx%, yy%)
DECLARE FUNCTION ScanVert% (xx%, yy%)
DEFINT A-Z
'$INCLUDE: 'DIRECTQB.BI'
'$DYNAMIC
CLEAR , , 4000
DIM SHARED Path$
DIM SHARED s20x20: s20x20 = 500
DIM SHARED Walk AS DOUBLE, Player, Fixed, Coins, Weapon, HVStat
DIM SHARED Health, GCards, Fall, Jump, Dir, PlayName$, Level, GnozzShot
DIM SHARED Lxmax, Lymax, xdif, ydif, xdif2, ydif2
DIM SHARED Map(1 TO 100, 1 TO 100) AS STRING * 1
DIM SHARED FallSpeed, WalkSpeed, MaxJump, CardStat, CoinStat, DoorStat, SlimeStat
DIM SHARED PlasmStat, SawStat, LoadSaved, Ladder, GotoMenu, Sounds, Status, cmd$
DIM SHARED BeamStat, ZielStat, Shot, Shotd
DIM SHARED Exploxp, Exployp, Explo, ExploHard, pain
DIM SHARED Tile%(s20x20, 0 TO 42)
DIM SHARED Explo1%(s20x20, 0 TO 10)
DIM SHARED You%(s20x20, 0 TO 19)
DIM SHARED SndStat%(s20x20, 0 TO 3)
DIM SHARED WepStat%(s20x20, 0 TO 2)
DIM SHARED Sound$(1 TO 5)
DIM SHARED ArgNum, Arg$(1 TO 10), Rec$, OuTxt$
DIM SHARED pal AS STRING * 768, oldpal AS STRING * 768
DIM SHARED SinTable(0 TO 359) AS DOUBLE
DIM SHARED CosTable(0 TO 359) AS DOUBLE
CONST PI = 3.14159
FOR a = 0 TO 359
 SinTable(a) = SIN(a * PI / 180)
 CosTable(a) = COS(a * PI / 180)
NEXT a
TYPE VTrans: x AS INTEGER: y AS INTEGER: s AS INTEGER: d AS INTEGER: a AS INTEGER: END TYPE
TYPE HTrans: x AS INTEGER: y AS INTEGER: s AS INTEGER: d AS INTEGER: a AS INTEGER: END TYPE
TYPE Botter: x AS INTEGER: y AS INTEGER: d AS INTEGER: px AS INTEGER: py AS INTEGER: pa AS INTEGER: END TYPE
TYPE HSaw: x AS INTEGER: y AS INTEGER: s AS INTEGER: d AS INTEGER: a AS INTEGER: END TYPE
TYPE HV: x1 AS INTEGER: y1 AS INTEGER: x2 AS INTEGER: y2 AS INTEGER: END TYPE
TYPE Beamer: x1 AS INTEGER: y1 AS INTEGER: x2 AS INTEGER: y2 AS INTEGER: END TYPE
TYPE Pixelex: x AS INTEGER: y AS INTEGER: c AS INTEGER: xs AS INTEGER: ys AS INTEGER: END TYPE
TYPE Gnozz: x AS INTEGER: y AS INTEGER: d AS INTEGER: END TYPE
DIM SHARED MaxVTrans, VTrans(1 TO 20) AS VTrans
DIM SHARED MaxHTrans, HTrans(1 TO 20) AS HTrans
DIM SHARED MaxBotters, Botter(1 TO 20) AS Botter
DIM SHARED MaxHSaws, HSaw(1 TO 20) AS HSaw
DIM SHARED MaxHVs, HV(1 TO 20) AS HV
DIM SHARED MaxBeamers, Beamer(1 TO 20) AS Beamer
DIM SHARED Pixelex(1 TO 400) AS Pixelex
DIM SHARED MaxGnozz, Gnozz(1 TO 20) AS Gnozz, GnozzStat
'----------------------------------------------------------------------------

'Wenn das Programm die Dateien nicht finden kann,
'hier den Pfad eingeben (mit abschlieendem Backslash).
Path$ = ""

FallSpeed = 4 'Anzahl Pixel, die man in einem Durchlauf hinunterfllt
WalkSpeed = 6 'Anzahl Pixel, mit der man sich nach rechts/links bewegt
MaxJump = 12  'Maximale Sprunghhe
MaxFall = 3   'Anzahl Felder ab der man Fallschaden nimmt (+ Toleranz 10 Pixel)

'----------------------------------------------------------------------------
CLS
COLOR 0, 4: PRINT " MARSBASE v1.00                               Copyright(C) 2004 by ICC Software ": PRINT
COLOR 7, 0: PRINT "Loading DQB........";
IF DQBinit(10, 0, 0) THEN SysErr 1, "10 Layer, 0 Sounds"
IF DQBloadFont(Path$ + "graphics\hitech.fnt") THEN SysErr 2, Path$ + "graphics\hitech.fnt"
COLOR 2: PRINT "OK"
COLOR 7: PRINT "Loading Graphics...["; : LoadGraphics: PRINT "]"; : COLOR 2: PRINT " OK"
COLOR 7: PRINT "Loading Settings..."; : LoadSettings: COLOR 2: PRINT "OK"
dqbwait 20
DQBinitVGA

Player = 1
'                        GOTO StartGame
GetMenu:
'                        EndProg
GotoMenu = 0
dqbremovekeyboard
Choice = Menu
IF Choice = 1 THEN Player = ChoosePlayer: IF Player = 0 THEN GOTO GetMenu ELSE GOTO StartGame
IF Choice = 2 THEN Story: GOTO GetMenu
IF Choice = 3 THEN Instructions: GOTO GetMenu
IF Choice = 4 THEN Credits: GOTO GetMenu
IF Choice = 5 THEN EndProg

'----- GAME -----------------------------------------------------------------
StartGame:
pain = 0
falled = 0
ClearLayers
LoadPlayer Player
IF PlayName$ = "" THEN Get.Put.PlayerName Player

dqbinstallkeyboard

LoadIMG 2, "mbasebg.bmp", 0, 0, 320, 200
Put.Status
GOSUB UpdateMap
DO

FOR a = 0 TO 1000: NEXT a

IF GotoMenu = 1 THEN GotoMenu = 0: GOTO GetMenu
'----------------------------------------------------------------------------
IF LoadSaved > 1 THEN
 IF LoadSaved = 10 THEN dqbclearlayer 8: Put.Status: LoadIMG 8, "disk.bmp", 0, 0, 64, 64
 LoadSaved = LoadSaved - 1
ELSEIF LoadSaved = 1 THEN
 dqbclearlayer 8: Put.Status
 LoadSaved = 0
END IF
IF pain > 0 THEN
 pain = pain - 1
 PlaySound "pain"
 Put.1Tile 0, 149 + INT(RND * 40) - 20, 89 + INT(RND * 40) - 20, CHR$(0)
 dqbscroll 0, 2, 2
 dqbscroll 0, -4, -4
 dqbscroll 0, 2, 2
 Fixed = 0
END IF
IF Explo > 0 THEN
 FOR b = 1 TO ExploHard
  dqbput 0, Exploxp + INT(RND * ExploHard * 2) - ExploHard - 10, Exployp + INT(RND * ExploHard * 2) - ExploHard - 10, VARSEG(Explo1%(s20x20, (10 - Explo))), VARPTR(Explo1%(s20x20, (10 - Explo)))
 NEXT b
 r = (10 - Explo) * 3
 dqbellipse 0, Exploxp, Exployp, r, r * 2, 14
 dqbellipse 0, Exploxp, Exployp, r, r, 4
 dqbellipse 0, Exploxp, Exployp, r * 2, r, 9
 Explo = Explo - 1
END IF
'----------------------------------------------------------------------------
LxPos = (xdif + 179) \ 20
LyPos = (ydif + 119) \ 20
IF Map(LxPos, LyPos) = "1" THEN GCards = GCards + 1: Map(LxPos, LyPos) = " ": Put.Status: PlaySound "getkey"
IF Map(LxPos, LyPos) = "$" THEN Coins = Coins + 1: Map(LxPos, LyPos) = " ": Put.Status: PlaySound "getcoin"
IF Map(LxPos, LyPos) = "a" THEN Health = Health + 25: Map(LxPos, LyPos) = " ": Put.Status: PlaySound "getmedic"
IF Map(LxPos - 1, LyPos) = "d" AND Dir = -1 AND GCards > 0 THEN GCards = GCards - 1: Put.Status: PlaySound "opendoor": Map(LxPos - 1, LyPos) = "o"
IF Map(LxPos + 1, LyPos) = "d" AND Dir = 1 AND GCards > 0 THEN GCards = GCards - 1: Put.Status: PlaySound "opendoor": Map(LxPos + 1, LyPos) = "o"
IF Map(LxPos, LyPos) = "w" THEN Weapon = 1: Put.Status: PlaySound "weapon": Map(LxPos, LyPos) = " "
IF Map(LxPos, LyPos) = "l" THEN
 IF Ladder = FALSE THEN Ladder = TRUE
ELSE
 IF Ladder = TRUE THEN Ladder = FALSE
END IF
IF Map(LxPos, LyPos) = "i" THEN Health = 0: Put.Status
IF Map(LxPos, LyPos) = "#" THEN WarpToNextLevel: GOTO GetMenu

IF DQBkey(1) THEN GOTO PlayMenu
IF DQBkey(57) THEN
 doof$ = DQBinkey$
 IF Map(LxPos, LyPos) = "|" THEN HVStat = FALSE: Map(LxPos, LyPos) = "-": PlaySound "off": GOTO JumpOver2
 IF Map(LxPos, LyPos) = "-" THEN HVStat = TRUE: Map(LxPos, LyPos) = "|": PlaySound "on"
JumpOver2:
END IF
IF DQBkey(29) AND Shot = 0 AND Ladder = FALSE AND Weapon > 0 THEN
 Shot = 2
 Shoty = 89 + 8
 Shotd = Dir
 Shoty1 = Shoty
 Shoty2 = Shoty
 IF Dir = 1 THEN Shotx1 = 149 + 20: Shotx2 = 319 ELSE Shotx1 = 149 - 1: Shotx2 = 0
 dqbline 0, Shotx1, Shoty, Shotx2, Shoty, 4
 PlaySound "shot" + Kurz$(STR$(Weapon))
END IF
IF DQBkey(60) THEN ScreenShot
IF DQBkey(61) THEN Pause
IF DQBkey(87) THEN
 doof$ = DQBinkey$
 IF Sounds = 0 THEN Sounds = 1 ELSE Sounds = 0
 SaveSettings
 Put.Status
 DoLayer
END IF
IF DQBkey(88) THEN
 doof$ = DQBinkey$
 IF Status = FALSE THEN
  PlaySound "on": Status = TRUE: SaveSettings: Put.Status: DoLayer
 ELSE
  PlaySound "off": Status = FALSE: SaveSettings: dqbclearlayer 8: DoLayer
 END IF
END IF
IF DQBkey(63) THEN SavePlayer Player: LoadSaved = 10
IF DQBkey(66) THEN LoadPlayer Player: GOTO StartGame
IF DQBkey(KEYLEFT) AND Fixed = 0 THEN cmd$ = "go_left"
IF DQBkey(KEYRIGHT) AND Fixed = 0 THEN cmd$ = "go_right"
IF DQBkey(KEYUP) AND Fall = FALSE AND Jump = FALSE THEN
 Fixed = 0
 IF Ladder = FALSE THEN
  Jump = TRUE: Walk = 2: vp = MaxJump
 ELSE
  cmd$ = "go_up"
 END IF
END IF
IF DQBkey(KEYDOWN) AND Ladder = TRUE THEN cmd$ = "go_down"

IF Jump = TRUE THEN
vp = vp - 1
IF vp <= 0 THEN Jump = FALSE
FOR a = 0 TO vp - 1
 IF ScanHor(149, 88 - a) = TRUE THEN
  ydif = ydif - 1
  IF Sounds = 1 THEN SOUND 440 - vp, .03
 ELSE
  Jump = FALSE
  EXIT FOR
 END IF
NEXT a
END IF

GOSUB DoCmd
LOOP
'----------------------------------------------------------------------------
DoCmd:
oldxdif = xdif
oldydif = ydif
SELECT CASE cmd$
CASE "go_left"
 IF ScanVert(149 + 3, 89) = TRUE THEN dqbscroll 2, 1, 0
 Dir = -1: IF Jump = FALSE THEN Walk = Walk + WalkSpeed / 15 ELSE Walk = 2
 FOR a = 0 TO WalkSpeed - 1
  IF ScanVert(149 + 3 - a, 89) = TRUE THEN xdif = xdif - 1
 NEXT a
CASE "go_right"
 IF ScanVert(149 + 16, 89) = TRUE THEN dqbscroll 2, -1, 0
 Dir = 1: IF Jump = FALSE THEN Walk = Walk + WalkSpeed / 15 ELSE Walk = 2
 FOR a = 0 TO WalkSpeed - 1
  IF ScanVert(149 + 16 + a, 89) = TRUE THEN xdif = xdif + 1
 NEXT a
CASE "go_up"
 Walk = Walk + WalkSpeed / 8
 FOR a = 0 TO WalkSpeed - 1
  IF ScanHor(149, 88 - a) = TRUE THEN ydif = ydif - 1
 NEXT a
CASE "go_down"
 Walk = Walk + WalkSpeed / 8
 FOR a = 0 TO WalkSpeed - 1
  IF ScanHor(149, 89 + 20 + a) = TRUE THEN ydif = ydif + 1
 NEXT a
END SELECT
cmd$ = ""
Fall = FALSE
IF ScanHor(149, 89 + 20) = TRUE AND Jump = FALSE AND Ladder = FALSE AND Fixed = 0 THEN
 FOR a = 1 TO FallSpeed
 IF ScanHor(149, 89 + 19 + a) = TRUE THEN ydif = ydif + 1: Walk = 2: Fall = TRUE: falled = falled + 1 ELSE Fall = FALSE: Jump = FALSE
 NEXT a
ELSE
 IF falled > 0 THEN
 IF falled > MaxFall * 20 + 10 AND Fixed = 0 THEN 'Fallschaden
  Health = Health - falled / 30
  Put.Status
  PlaySound "hardbump"
  pain = falled / 50
  Explo = 0
 END IF
 falled = 0: Walk = 1: PlaySound "bump"
 END IF
END IF

GOSUB UpdateMap
RETURN
'----------------------------------------------------------------------------
UpdateMap:
IF Shot > 0 THEN
 Shot = Shot - 1
 Shotx1 = Shotx1 + Shotd
 Shotx2 = Shotx2 - Shotd
 Shoty1 = Shoty1 + Shotd
 Shoty2 = Shoty2 - Shotd
 dqbline 0, Shotx1, Shoty1, Shotx2, Shoty1, 40 + Shot
 dqbline 0, Shotx1, Shoty2, Shotx2, Shoty2, 40 + Shot
END IF
' Animation bestimmter Objekte erzeugen
CardStat = CardStat + 4: IF CardStat >= 60 THEN CardStat = 0
DoorStat = DoorStat + 2:  IF DoorStat >= 8 THEN DoorStat = 0
CoinStat = CoinStat + 1: IF CoinStat >= 8 THEN CoinStat = 0
SlimeStat = SlimeStat + 1: IF SlimeStat >= 10 THEN SlimeStat = 0
SawStat = SawStat + 50: IF SawStat > 255 THEN SawStat = 0
BeamStat = BeamStat + 1: IF BeamStat >= 3 THEN BeamStat = 1
GnozzStat = GnozzStat + 2: IF GnozzStat >= 8 THEN GnozzStat = 0
ZielStat = ZielStat + 1: IF ZielStat >= 8 THEN ZielStat = 0
Put.Tiles xdif, ydif
Put.Objects xdif, ydif
IF Walk >= 3 THEN Walk = 1
Put.Player INT(Walk), Weapon, Dir
DoLayer
RETURN
'----------------------------------------------------------------------------
PlayMenu:
EndProg
RETURN
'----------------------------------------------------------------------------

REM $STATIC
'
'Erzeugt einen Beam-Effekt
'
SUB Beamto (xdif2, ydif2)
IF xdif2 < xdif THEN xdifstep = -1 ELSE xdifstep = 1
IF ydif2 < ydif THEN ydifstep = -1 ELSE ydifstep = 1
IF xdif = xdif2 THEN xdifstep = 0
IF ydif = ydif2 THEN ydifstep = 0
Frame = 9
PlaySound "beam"
dqbclearlayer 5
DO
Frame = Frame + 1
IF Frame >= 20 THEN
Frame = 0
BeamStat = BeamStat + 1
Put.Tiles xdif, ydif
FOR x = -320 TO 320 STEP 2
dqbline 3, x, 0, 320 + x, 320, ABS(x) / 20 + 16
dqbline 3, 320 + x, 0, x, 320, ABS(x) / 20 + 16
NEXT x
Fra2 = Fra2 + 1
dqbclearlayer 4
IF Fra2 > 4 THEN Fra2 = 1
dqbput 4, 149, 89, VARSEG(You%(s20x20, 6 + Fra2)), VARPTR(You%(s20x20, 6 + Fra2))
DoLayer
END IF

xdif = xdif + xdifstep
ydif = ydif + ydifstep
IF xdif = xdif2 THEN xdifstep = 0
IF ydif = ydif2 THEN ydifstep = 0
IF xdifstep = 0 AND ydifstep = 0 THEN EXIT DO
LOOP
END SUB

'
'ndert eine bestimmte Zeile in einer Datei.
'
SUB ChLine (lin, t$, FileName$)
nu = FREEFILE
OPEN FileName$ FOR INPUT AS #nu
nu2 = FREEFILE
OPEN Path$ + "~~~~~~~~.tmp" FOR OUTPUT AS #nu2
rl = 0
DO WHILE NOT EOF(1)
LINE INPUT #1, Rec$: rl = rl + 1
IF rl = lin THEN PRINT #nu2, t$ ELSE PRINT #nu2, Rec$
LOOP
CLOSE #nu, #nu2
KILL FileName$
NAME Path$ + "~~~~~~~~.tmp" AS FileName$
END SUB

REM $DYNAMIC
'
'Zeigt den Bildschirm an, bei dem man den Spieler auswhlen muss.
'
FUNCTION ChoosePlayer
ClearLayers
p = 1
readnames:

nu = FREEFILE
OPEN Path$ + "LEVELS\SAVED\player1.sav" FOR INPUT AS #nu
LINE INPUT #1, PN1$: CLOSE #nu
OPEN Path$ + "LEVELS\SAVED\player2.sav" FOR INPUT AS #nu
LINE INPUT #1, PN2$: CLOSE #nu
OPEN Path$ + "LEVELS\SAVED\player3.sav" FOR INPUT AS #nu
LINE INPUT #1, PN3$: CLOSE #nu

LoadPlayer 1: dqbprint 9, PlayName$, 93 - LEN(PN1$) * 8 / 2, 44, 1
LoadPlayer 2: dqbprint 9, PlayName$, 160 - LEN(PN2$) * 8 / 2, 44, 4
LoadPlayer 3: dqbprint 9, PlayName$, 227 - LEN(PN3$) * 8 / 2, 44, 2

ch = 1
DO
a$ = INKEY$
IF a$ = CHR$(0) + CHR$(60) THEN ScreenShot
IF a$ = CHR$(27) THEN PlaySound "enter": ChoosePlayer = 0: EXIT DO
IF a$ = CHR$(13) THEN PlaySound "enter": ChoosePlayer = p: EXIT DO
IF a$ = CHR$(0) + "K" AND p > 1 THEN p = p - 1: ch = 1: PlaySound "switch"
IF a$ = CHR$(0) + "M" AND p < 3 THEN p = p + 1: ch = 1: PlaySound "switch"
IF a$ = CHR$(0) + "S" THEN
LoadIMG 8, "yndelpla.bmp", 59, 114, 200, 70
DoLayer
PlaySound "dialog"
DO
a$ = LCASE$(INKEY$)
IF a$ = "j" THEN
 f$ = Path$ + "LEVELS\SAVED\player" + Kurz$(STR$(p)) + ".sav"
 G$ = Path$ + "LEVELS\CLEAN\map1.lev"
 nu = FREEFILE: OPEN f$ FOR OUTPUT AS #nu
 nu2 = FREEFILE: OPEN G$ FOR INPUT AS #nu2
 DO WHILE NOT EOF(nu2): LINE INPUT #nu2, doof$: PRINT #nu, doof$: LOOP
 CLOSE #nu, #nu2
 EXIT DO
END IF
IF a$ = "n" OR a$ = CHR$(27) THEN EXIT DO
LOOP
PlaySound "enter"
dqbclearlayer 8
dqbclearlayer 9
GOTO readnames
END IF
IF ch = 1 THEN
 ch = 0
 LoadIMG 8, "whichpl.bmp", 0, 0, 320, 200
 dqbsetpal pal
 IF p = 1 THEN DQBpaint 8, 70, 64, 15
 IF p = 2 THEN DQBpaint 8, 140, 64, 15
 IF p = 3 THEN DQBpaint 8, 205, 64, 15
END IF
DoLayer
LOOP
dqbfadeto 0, 0, 0
ClearLayers
dqbsetpal oldpal
END FUNCTION

'
'Lscht alle Layer
'
SUB ClearLayers
FOR a = 0 TO 10
 dqbclearlayer a
NEXT a
END SUB

'
'Zeigt die "Credits" an
'
SUB Credits
LoadIMG 0, "credits.bmp", 0, 0, 320, 200
dqbsetpal pal
DO: LOOP WHILE INKEY$ = ""
dqbsetpal oldpal
FOR a = 1 TO 15: a$ = INKEY$: NEXT a
END SUB

REM $STATIC
'
'Hier sollte man whrend des Spiels mglichst nicht hinkommen...
'"You've been pulverized !"-Bildschirm
'
SUB Death
EXIT SUB
doof$ = DQBinkey$
DoPixelex 4, 9, 149, 89
pain = 0
Explo = 0
FOR y = 0 TO 98 STEP 3
dqbboxf 0, 0, y, 319, y + 3, 16
dqbboxf 0, 0, 199 - y - 1, 319, 199 - y + 3, 16
dqbwait 1
NEXT y
FOR x = 0 TO 159
dqbboxf 0, x, 98, x, 101, 16
dqbboxf 0, 319 - x, 98, 319 - x, 101, 16
SOUND 0, .1
NEXT x
PlaySound "woosh"
dqbgetpal pal
dqbfadeto 63, 63, 63
dqbclearlayer 0
dqbsetpal pal
LoadIMG 0, "pulver.bmp", 0, 0, 320, 200
pal = CHR$(63) + CHR$(63) + CHR$(63) + RIGHT$(pal, 765)
dqbsetpal pal
SLEEP 1
dqbfadeto 0, 0, 0
ClearLayers
dqbsetpal oldpal
END SUB

REM $DYNAMIC
'
'Kopiert alle Layer bereinander
'
SUB DoLayer
DQBcopyLayer 2, 1      ' 2: Background 1
DQBcopyTransLayer 3, 1 ' 3: Background 2
DQBcopyTransLayer 4, 1 ' 4: Walkground 1
DQBcopyTransLayer 5, 1 ' 5: Walkground 2
DQBcopyTransLayer 6, 1 ' 6: Foreground 1
DQBcopyTransLayer 7, 1 ' 7: Foreground 1
DQBcopyTransLayer 8, 1 ' 8: Temp 1 / Status layer
DQBcopyTransLayer 9, 1 ' 9: Temp 2
'dqbcopytranslayer 10, 1
		       '10: Real Walkground #1
DQBcopyLayer 1, 0
END SUB

REM $STATIC
'
'Erzeugt einen Explosionseffekt, bei dem die Pixel "auseinander-bersten"
'
SUB DoPixelex (layer1, layer2, xp, yp)
p = 0
PlaySound "rayblast"
FOR xx = xp TO xp + 19
FOR yy = yp TO yp + 19
p = p + 1
Pixelex(p).x = xx
Pixelex(p).y = yy
Pixelex(p).c = DQBpoint(layer1, xx, yy)
a = INT(RND * 10) + 2: IF INT(RND * 2) + 1 = 1 THEN a = -a
b = INT(RND * 10) + 2: IF INT(RND * 2) + 1 = 1 THEN b = -b
Pixelex(p).xs = a
Pixelex(p).ys = b
NEXT yy
NEXT xx
dqbclearlayer layer1
FOR a = 1 TO 50
dqbclearlayer layer2
SOUND a * 40 + 40, .03
FOR p = 1 TO 400
dqbpset layer2, Pixelex(p).x, Pixelex(p).y, Pixelex(p).c
Pixelex(p).x = Pixelex(p).x + Pixelex(p).xs
Pixelex(p).y = Pixelex(p).y + Pixelex(p).ys
NEXT p
DoLayer
NEXT a
END SUB

REM $DYNAMIC
'
'Deinitialisiert alles.
'
SUB EndProg
dqbremovekeyboard
dqbclose
COLOR 7, 0
CLS
PRINT "MARSBASE v1.00"
PRINT "Bis zum nchsten Mal ;)"
END
END SUB

REM $STATIC
SUB ExploGnozz (xp, yp, a)
GnozzShot = GnozzShot + 1: Put.Status
PlaySound "explo1": Gnozz(a).d = 0
END SUB

REM $DYNAMIC
'
'Ermittelt den Spielernamen
'
SUB Get.Put.PlayerName (Player)
ClearLayers
LoadIMG 8, "typename.bmp", 59, 59, 200, 71
dqbsetpal pal
txt$ = ""
ch = 1
DoLayer
PlaySound "dialog"
DO
a$ = INKEY$
IF NOT a$ = "" THEN
 a = ASC(UCASE$(a$))
 IF a >= 33 AND a <= 94 THEN
  IF LEN(txt$) < 8 THEN txt$ = txt$ + CHR$(a) ELSE txt$ = LEFT$(txt$, 7) + CHR$(a)
  PlaySound "mtype"
  ch = 1
 END IF
 IF a = 8 AND LEN(txt$) > 0 THEN txt$ = LEFT$(txt$, LEN(txt$) - 1): ch = 1
 IF a = 13 AND NOT Kurz$(txt$) = "" THEN EXIT DO
END IF
IF ch = 1 THEN
 ch = 0
 dqbclearlayer 9
 dqbprint 9, txt$ + "_", 59 + 19, 59 + 56, 15
 DoLayer
END IF
LOOP
PlaySound "enter"
dqbfadeto 0, 0, 0
ClearLayers
dqbsetpal oldpal
PlayName$ = txt$
ChLine 1, txt$, Path$ + "LEVELS\SAVED\player" + Kurz$(STR$(Player)) + ".sav"
DoLayer
END SUB

REM $STATIC
'
'Zeigt den "Steuerung" Bildschirm an
'
SUB Instructions
LoadIMG 0, "instr.bmp", 0, 0, 320, 200
dqbsetpal pal
DO: LOOP WHILE INKEY$ = ""
dqbsetpal oldpal
FOR a = 1 TO 15: a$ = INKEY$: NEXT a
END SUB

REM $DYNAMIC
'
'Befreit einen String von Leerzeichen am Rand
'
FUNCTION Kurz$ (a$)
Kurz$ = LTRIM$(RTRIM$(a$))
END FUNCTION

'
'Ldt eine G&AT Bilddatei
'Danke E-P-S ;)
'
SUB LoadGAT (FileName$)
nu = FREEFILE
OPEN Path$ + "GRAPHICS\" + FileName$ FOR BINARY AS #nu
a$ = SPACE$(8): GET #nu, , a$
a$ = "X": GET #nu, , a$
b$ = "X": GET #nu, , b$
h$ = "X": GET #nu, , h$
Tr$ = "X": GET #nu, , Tr$
dqbboxf 1, 0, 0, ASC(b$) - 1, ASC(h$) - 1, 0
FOR xx = 0 TO ASC(b$) - 1
 FOR yy = 0 TO ASC(h$) - 1
  a$ = "X": GET #nu, , a$
  dqbpset 1, xx, yy, ASC(a$)
 NEXT
NEXT
CLOSE #nu
END SUB

REM $STATIC
'
'Ldt smtliche Tilesets und Sprites.
'
SUB LoadGraphics
LoadGAT "steel1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 1)), VARPTR(Tile%(s20x20, 1)): PRINT "";
LoadGAT "steel2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 2)), VARPTR(Tile%(s20x20, 2)): PRINT "";
LoadGAT "stein1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 3)), VARPTR(Tile%(s20x20, 3)): PRINT "";
LoadGAT "vtrans.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 4)), VARPTR(Tile%(s20x20, 4)): PRINT "";
LoadGAT "stairs.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 5)), VARPTR(Tile%(s20x20, 5)): PRINT "";
LoadGAT "door1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 6)), VARPTR(Tile%(s20x20, 6)): PRINT "";
LoadGAT "door2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 7)), VARPTR(Tile%(s20x20, 7)): PRINT "";
LoadGAT "gcard1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 8)), VARPTR(Tile%(s20x20, 8)): PRINT "";
LoadGAT "gcard2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 9)), VARPTR(Tile%(s20x20, 9)): PRINT "";
LoadGAT "gcard3.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 10)), VARPTR(Tile%(s20x20, 10)): PRINT "";
LoadGAT "gcard4.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 11)), VARPTR(Tile%(s20x20, 11)): PRINT "";
LoadGAT "odoor.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 12)), VARPTR(Tile%(s20x20, 12)): PRINT "";
LoadGAT "ramp1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 13)), VARPTR(Tile%(s20x20, 13)): PRINT "";
LoadGAT "ramp2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 14)), VARPTR(Tile%(s20x20, 14)): PRINT "";
LoadGAT "coin1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 15)), VARPTR(Tile%(s20x20, 15)): PRINT "";
LoadGAT "coin2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 16)), VARPTR(Tile%(s20x20, 16)): PRINT "";
LoadGAT "ouch.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 17)), VARPTR(Tile%(s20x20, 17)): PRINT "";
LoadGAT "htrans.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 18)), VARPTR(Tile%(s20x20, 18)): PRINT "";
LoadGAT "lbotter.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 19)), VARPTR(Tile%(s20x20, 19)): PRINT "";
LoadGAT "rbotter.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 20)), VARPTR(Tile%(s20x20, 20)): PRINT "";
LoadGAT "lpulse1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 21)), VARPTR(Tile%(s20x20, 21)): PRINT "";
LoadGAT "lpulse2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 22)), VARPTR(Tile%(s20x20, 22)): PRINT "";
LoadGAT "rpulse1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 23)), VARPTR(Tile%(s20x20, 23)): PRINT "";
LoadGAT "rpulse2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 24)), VARPTR(Tile%(s20x20, 24)): PRINT "";
LoadGAT "medic.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 25)), VARPTR(Tile%(s20x20, 25)): PRINT "";
LoadGAT "slime1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 26)), VARPTR(Tile%(s20x20, 26)): PRINT "";
LoadGAT "slime2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 27)), VARPTR(Tile%(s20x20, 27)): PRINT "";
LoadGAT "saw.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 28)), VARPTR(Tile%(s20x20, 28)): PRINT "";
LoadGAT "slime3.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 29)), VARPTR(Tile%(s20x20, 29)): PRINT "";
LoadGAT "slime4.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 30)), VARPTR(Tile%(s20x20, 30)): PRINT "";
LoadGAT "hv1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 31)), VARPTR(Tile%(s20x20, 31)): PRINT "";
LoadGAT "hv2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 32)), VARPTR(Tile%(s20x20, 32)): PRINT "";
LoadGAT "hvswit1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 33)), VARPTR(Tile%(s20x20, 33)): PRINT "";
LoadGAT "hvswit2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 34)), VARPTR(Tile%(s20x20, 34)): PRINT "";
LoadGAT "iccsteel.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 35)), VARPTR(Tile%(s20x20, 35)): PRINT "";
LoadGAT "beam1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 36)), VARPTR(Tile%(s20x20, 36)): PRINT "";
LoadGAT "beam2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 37)), VARPTR(Tile%(s20x20, 37)): PRINT "";
LoadGAT "gnozz1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 38)), VARPTR(Tile%(s20x20, 38)): PRINT "";
LoadGAT "gnozz2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 39)), VARPTR(Tile%(s20x20, 39)): PRINT "";
LoadGAT "ziel1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 40)), VARPTR(Tile%(s20x20, 40)): PRINT "";
LoadGAT "ziel2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(Tile%(s20x20, 41)), VARPTR(Tile%(s20x20, 41)): PRINT "";

LoadGAT "your1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 1)), VARPTR(You%(s20x20, 1)): PRINT "";
LoadGAT "your2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 2)), VARPTR(You%(s20x20, 2)): PRINT "";
LoadGAT "youl1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 3)), VARPTR(You%(s20x20, 3)): PRINT "";
LoadGAT "youl2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 4)), VARPTR(You%(s20x20, 4)): PRINT "";
LoadGAT "climb1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 5)), VARPTR(You%(s20x20, 5)): PRINT "";
LoadGAT "climb2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 6)), VARPTR(You%(s20x20, 6)): PRINT "";
LoadGAT "plasma1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 7)), VARPTR(You%(s20x20, 7)): PRINT "";
LoadGAT "plasma2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 8)), VARPTR(You%(s20x20, 8)): PRINT "";
LoadGAT "plasma3.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 9)), VARPTR(You%(s20x20, 9)): PRINT "";
LoadGAT "plasma4.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 10)), VARPTR(You%(s20x20, 10)): PRINT "";
LoadGAT "armr1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 11)), VARPTR(You%(s20x20, 11)): PRINT "";
LoadGAT "armr2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 12)), VARPTR(You%(s20x20, 12)): PRINT "";
LoadGAT "arml1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 13)), VARPTR(You%(s20x20, 13)): PRINT "";
LoadGAT "arml2.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 14)), VARPTR(You%(s20x20, 14)): PRINT "";
LoadGAT "wep1r.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 15)), VARPTR(You%(s20x20, 15)): PRINT "";
LoadGAT "wep1l.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 16)), VARPTR(You%(s20x20, 16)): PRINT "";
'LoadGAT "wep2r.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 17)), VARPTR(You%(s20x20, 17)): PRINT "";
'LoadGAT "wep2l.gat": DQBget 1, 0, 0, 19, 19, VARSEG(You%(s20x20, 18)), VARPTR(You%(s20x20, 18)): PRINT "";

LoadGAT "nosound.gat": DQBget 1, 0, 0, 19, 19, VARSEG(SndStat%(s20x20, 1)), VARPTR(SndStat%(s20x20, 1)): PRINT "";
LoadGAT "speaker.gat": DQBget 1, 0, 0, 19, 19, VARSEG(SndStat%(s20x20, 2)), VARPTR(SndStat%(s20x20, 2)): PRINT "";

LoadGAT "wep1.gat": DQBget 1, 0, 0, 19, 19, VARSEG(WepStat%(s20x20, 1)), VARPTR(WepStat%(s20x20, 1)): PRINT "";

LoadIMG 1, "explo1.bmp", 0, 0, 320, 20
b = 0
FOR a = 0 TO 179 STEP 20
b = b + 1
DQBget 1, 0 + a, 0, 19 + a, 19, VARSEG(Explo1%(s20x20, b)), VARPTR(Explo1%(s20x20, b)): PRINT "";
NEXT a
END SUB

'
'Ldt ein Bild.
'
SUB LoadIMG (Layer, FileName$, xx, yy, xs, ys)
dqbgetpal oldpal
FileName$ = Path$ + "GRAPHICS\" + FileName$
IF DQBloadImage(Layer, xx, yy, FileName$, pal, xs, ys) THEN SysErr 3, FileName$
END SUB

REM $DYNAMIC
'
'Ldt einen Spielstand.
'
SUB LoadPlayer (Player)
MaxVTrans = 0
MaxHTrans = 0
MaxBotters = 0
MaxHSaws = 0
MaxHVs = 0
MaxBeamers = 0
MaxGnozz = 0

nu = FREEFILE
OPEN Path$ + "LEVELS\SAVED\player" + Kurz$(STR$(Player)) + ".sav" FOR INPUT AS #nu
LINE INPUT #nu, PlayName$
LINE INPUT #nu, doof$: Level = VAL(doof$)
LINE INPUT #nu, doof$: Lxmax = VAL(doof$)
LINE INPUT #nu, doof$: Lymax = VAL(doof$)
LINE INPUT #nu, doof$: xdif = VAL(doof$)
LINE INPUT #nu, doof$: ydif = VAL(doof$)
LINE INPUT #nu, doof$: Dir = VAL(doof$)
LINE INPUT #nu, doof$: Fixed = VAL(doof$)
LINE INPUT #nu, doof$: Jump = VAL(doof$)
LINE INPUT #nu, doof$: Fall = VAL(doof$)
LINE INPUT #nu, doof$: Coins = VAL(doof$)
LINE INPUT #nu, doof$: Health = VAL(doof$)
LINE INPUT #nu, doof$: GCards = VAL(doof$)
LINE INPUT #nu, doof$: GnozzShot = VAL(doof$)
LINE INPUT #nu, doof$: Walk = VAL(doof$)
LINE INPUT #nu, doof$: Weapon = VAL(doof$)
LINE INPUT #nu, doof$: HVStat = VAL(doof$)

FOR y = 1 TO Lymax
 LINE INPUT #nu, z$
 FOR x = 1 TO LEN(z$)
  a$ = MID$(z$, x, 1)

  IF a$ = "*" THEN
   xdif = -169 + x * 20
   ydif = -109 + y * 20
   a$ = " "
  END IF
  Map(x, y) = a$
 NEXT x
NEXT y

DO WHILE NOT EOF(1)
 LINE INPUT #1, Rec$
 IF SC("obj vtrans ") THEN
  MaxVTrans = MaxVTrans + 1
  IF Arg$(4) = "" THEN
   VTrans(MaxVTrans).x = (VAL(Arg$(1)) - 1) * 20
   VTrans(MaxVTrans).y = (VAL(Arg$(2)) - 1) * 20
   VTrans(MaxVTrans).s = VTrans(MaxVTrans).y + (VAL(Arg$(3)) - 1) * 20
   VTrans(MaxVTrans).d = 2
   VTrans(MaxVTrans).a = VTrans(MaxVTrans).y
  ELSE
   VTrans(MaxVTrans).x = VAL(Arg$(4))
   VTrans(MaxVTrans).y = VAL(Arg$(5))
   VTrans(MaxVTrans).s = VAL(Arg$(6))
   VTrans(MaxVTrans).d = VAL(Arg$(7))
   VTrans(MaxVTrans).a = VAL(Arg$(8))
  END IF
 END IF
 IF SC("obj htrans ") THEN
  MaxHTrans = MaxHTrans + 1
  IF Arg$(4) = "" THEN
   HTrans(MaxHTrans).x = (VAL(Arg$(1)) - 1) * 20
   HTrans(MaxHTrans).y = (VAL(Arg$(2)) - 1) * 20
   HTrans(MaxHTrans).s = HTrans(MaxHTrans).x + (VAL(Arg$(3)) - 1) * 20
   HTrans(MaxHTrans).d = 2
   HTrans(MaxHTrans).a = HTrans(MaxHTrans).x
  ELSE
   HTrans(MaxHTrans).x = VAL(Arg$(4))
   HTrans(MaxHTrans).y = VAL(Arg$(5))
   HTrans(MaxHTrans).s = VAL(Arg$(6))
   HTrans(MaxHTrans).d = VAL(Arg$(7))
   HTrans(MaxHTrans).a = VAL(Arg$(8))
  END IF
 END IF
 IF SC("obj hsaw ") THEN
  MaxHSaws = MaxHSaws + 1
  IF Arg$(4) = "" THEN
   HSaw(MaxHSaws).x = (VAL(Arg$(1)) - 1) * 20
   HSaw(MaxHSaws).y = (VAL(Arg$(2)) - 1) * 20
   HSaw(MaxHSaws).s = HSaw(MaxHSaws).x + (VAL(Arg$(3)) - 1) * 20
   HSaw(MaxHSaws).d = 2
   HSaw(MaxHSaws).a = HSaw(MaxHSaws).x
  ELSE
   HSaw(MaxHSaws).x = VAL(Arg$(4))
   HSaw(MaxHSaws).y = VAL(Arg$(5))
   HSaw(MaxHSaws).s = VAL(Arg$(6))
   HSaw(MaxHSaws).d = VAL(Arg$(7))
   HSaw(MaxHSaws).a = VAL(Arg$(8))
  END IF
 END IF
 IF SC("obj hv ") THEN
 MaxHVs = MaxHVs + 1
 x1 = VAL(Arg$(1))
 y1 = VAL(Arg$(2))
 x2 = VAL(Arg$(3))
 y2 = VAL(Arg$(4))
 IF x2 < x1 THEN SWAP x1, x2: SWAP y1, y2
 Map(x1, y1) = CHR$(13): Map(x2, y2) = CHR$(14)
 x1 = (x1 - 1) * 20: y1 = (y1 - 1) * 20
 x2 = (x2 - 1) * 20: y2 = (y2 - 1) * 20
 HV(MaxHVs).x1 = x1
 HV(MaxHVs).y1 = y1
 HV(MaxHVs).x2 = x2
 HV(MaxHVs).y2 = y2
 END IF
 IF SC("obj beamer ") THEN
 MaxBeamers = MaxBeamers + 1
 x1 = VAL(Arg$(1))
 y1 = VAL(Arg$(2))
 x2 = VAL(Arg$(3))
 y2 = VAL(Arg$(4))
 Beamer(MaxBeamers).x1 = x1
 Beamer(MaxBeamers).y1 = y1
 Beamer(MaxBeamers).x2 = x2
 Beamer(MaxBeamers).y2 = y2
 Map(x1, y1) = CHR$(15)
 END IF
 IF SC("enemy botter ") THEN
 MaxBotters = MaxBotters + 1
 Botter(MaxBotters).x = (VAL(Arg$(1)) - 1) * 20
 Botter(MaxBotters).y = (VAL(Arg$(2)) - 1) * 20
 Botter(MaxBotters).pa = 0
 Botter(MaxBotters).px = -1000
 Botter(MaxBotters).py = -1000
 IF INT(RND * 2) + 1 = 1 THEN Botter(MaxBotters).d = 2 ELSE Botter(MaxBotters).d = -2
 END IF
 IF SC("enemy gnozz ") THEN
 MaxGnozz = MaxGnozz + 1
 Gnozz(MaxGnozz).x = (VAL(Arg$(1)) - 1) * 20
 Gnozz(MaxGnozz).y = (VAL(Arg$(2)) - 1) * 20
 IF INT(RND * 2) + 1 = 1 THEN Gnozz(MaxGnozz).d = 2 ELSE Gnozz(MaxGnozz).d = -2
 END IF
LOOP
CLOSE #nu
END SUB

SUB LoadSettings
nu = FREEFILE
OPEN Path$ + "settings.ini" FOR INPUT AS #nu
LINE INPUT #1, doof$: Sounds = VAL(doof$)
LINE INPUT #1, doof$: Status = VAL(doof$)
CLOSE #nu
END SUB

REM $STATIC
'
'Wird von SUB Story() benutzt, erzeugt einen Schreibmaschinenhnlichen
'Effekt.
'
SUB MachineType (Layer, kind, y, t$, Col)
FOR a = 1 TO LEN(t$)
a$ = LEFT$(t$, a)
dqbclearlayer Layer
IF kind = 0 THEN dqbprint Layer, a$, 1, y, Col
IF kind = 1 THEN dqbprint Layer, a$, 317 - LEN(a$) * 8, y, Col
DoLayer
IF a MOD 4 = 0 THEN PlaySound "mtype"
NEXT a
DQBcopyTransLayer Layer, Layer - 1
END SUB

'
'Zeigt das Hauptmen an.
'
FUNCTION Menu
ClearLayers
LoadIMG 8, "menubg.bmp", 0, 0, 320, 200
dqbsetpal pal
DIM s(1 TO 5) AS INTEGER, c(1 TO 5) AS INTEGER, L AS DOUBLE
s(1) = BOLD: c(1) = 15
s(2) = normal: c(2) = 8
s(3) = normal: c(3) = 8
s(4) = normal: c(4) = 8
s(5) = normal: c(5) = 8
p = 1
a = 0
L = 10
ent = 0
DO
a$ = INKEY$
IF ent = 0 THEN
IF a$ = CHR$(0) + CHR$(60) THEN ScreenShot
IF a$ = CHR$(0) + "H" THEN oldp = p: IF p > 1 THEN p = p - 1: ch = 1
IF a$ = CHR$(0) + "P" THEN oldp = p: IF p < 5 THEN p = p + 1: ch = 1
IF a$ = CHR$(27) THEN a$ = CHR$(13): p = 5
IF a$ = CHR$(13) THEN PlaySound "enter": Menu = p: ent = 1: IF NOT p = 1 AND NOT p = 5 THEN EXIT DO
END IF
IF ch = 1 THEN
ch = 0
SWAP s(oldp), s(p)
SWAP c(oldp), c(p)
PlaySound "switch"
END IF
dqbclearlayer 9
a = a + 1
IF a > 359 THEN a = 0
x = 80 + SinTable(a) * 50
y = 86 + CosTable(a) * 40
IF ent = 1 THEN L = L - .5
IF L < 0 THEN EXIT DO
DQBprints 9, "[*] Spiel Starten", x + 2, y + 2, 19, s(1)
DQBprints 9, "[*] Story", x + 2, y + L + 2, 19, s(2)
DQBprints 9, "[*] Steuerung", x + 2, y + L * 2 + 2, 19, s(3)
DQBprints 9, "[*] Credits", x + 2, y + L * 3 + 2, 19, s(4)
DQBprints 9, "[*] Beenden", x + 2, y + L * 4 + 2, 19, s(5)
DQBprints 9, "[*] Spiel Starten", x, y, c(1), s(1)
DQBprints 9, "[*] Story", x, y + L, c(2), s(2)
DQBprints 9, "[*] Steuerung", x, y + L * 2, c(3), s(3)
DQBprints 9, "[*] Credits", x, y + L * 3, c(4), s(4)
DQBprints 9, "[*] Beenden", x, y + L * 4, c(5), s(5)
DoLayer
LOOP
IF p = 1 OR p = 5 THEN dqbfadeto 0, 0, 0: ClearLayers
dqbsetpal oldpal
FOR a = 1 TO 15: a$ = INKEY$: NEXT a
EXIT FUNCTION
END FUNCTION

'
'Pausiert das Spiel
'
SUB Pause
dqbremovekeyboard
FOR a = 1 TO 15: doof$ = INKEY$: NEXT a
LoadIMG 0, "pause.bmp", 84, 74, 152, 52
PlaySound "woosh"
DO
LOOP WHILE INKEY$ = ""
FOR a = 1 TO 15: doof$ = INKEY$: NEXT a
dqbinstallkeyboard
END SUB

'
'Eigentlich befand sich in dieser SUB ein zustzlicher WAV-Player,
'der aber auf Grund von Speichermangel wieder herausgenommen werden musste.
'Traurig aber wahr.... der Sound war echt geil !
'
SUB PlaySound (Op$)
Op$ = UCASE$(Op$)
IF Sounds = 0 THEN EXIT SUB
SELECT CASE Op$
 CASE "ENTER": SOUND 1000, .4: SOUND 500, 1: SOUND 2000, 1
 CASE "SWITCH": SOUND 1000, .1: SOUND 200, 1
 CASE "DIALOG": PLAY "MB l20 gc"
 CASE "OPENDOOR":
  FOR a = 2000 TO 100 STEP -100
   SOUND a, .03
  NEXT a
 CASE "GETKEY": SOUND 100, .1: SOUND 1000, 1
 CASE "GETCOIN": SOUND 200, .1: SOUND 2000, 1
 CASE "WEAPON": SOUND 500, 1: SOUND 200, .4
 CASE "BUMP": SOUND 40, 1
 CASE "HARDBUMP": SOUND 50, 4
 CASE "PAIN": SOUND 50, .03: SOUND 1000, 1
 CASE "JUMP"
 CASE "SHOT1": SOUND 8000, 1: SOUND 1000, .3: SOUND 6000, 1
 CASE "EXPLO1": FOR a = 100 TO 1000 STEP 10: SOUND a, .03: NEXT a
 CASE "MTYPE": SOUND 100, .2: SOUND 50, .2
 CASE "ON": PLAY "l50 n10n20"
 CASE "OFF": PLAY "l50 n20n10"
 CASE "GETMEDIC": PLAY "l30gfgc<c<c<c>>>"
 CASE "WOOSH":
  FOR b = 100 TO 8000 STEP 100
  FOR a = 100 TO 8000 STEP b
  SOUND a, .03
  NEXT a
  NEXT b
 CASE "BEAM": PLAY "MB l64 n10n20n30n40n50n60n30n50n10n20n60"
END SELECT
END SUB

'
'Hier wird ein Tile dargestellt (entweder sichtbar oder auf dem Walk-Layer).
'Auerdem werden hier mittels Animationsvariablen (Pffix -Stat)
'Tiles animiert.
'
SUB Put.1Tile (Layer, x, y, t$)
x1 = 0: y1 = 0: x2 = 0: y2 = 0
SELECT CASE t$
 CASE "m": Num = 1: x1 = 0: y1 = 0: x2 = 19: y2 = 19
 CASE "s": Num = 2: x1 = 4: y1 = 0: x2 = 15: y2 = 19
 CASE "r": Num = 3: x1 = 0: y1 = 0: x2 = 19: y2 = 19
 CASE CHR$(4): Num = 4: x1 = 0: y1 = 4: x2 = 19: y2 = 15
 CASE "l": Num = 5
 CASE "d":
  x1 = 4: y1 = 0: x2 = 15: y2 = 19
  IF DoorStat >= 0 AND DoorStat < 4 THEN Num = 7
  IF DoorStat >= 4 AND DoorStat < 8 THEN Num = 6
 CASE "1", "2", "3", "4":
  IF CardStat >= 0 AND CardStat < 10 THEN Num = 8
  IF CardStat >= 10 AND CardStat < 20 THEN Num = 9
  IF CardStat >= 20 AND CardStat < 30 THEN Num = 10
  IF CardStat >= 30 AND CardStat < 40 THEN Num = 11
  IF CardStat >= 40 AND CardStat < 50 THEN Num = 10
  IF CardStat >= 50 AND CardStat < 60 THEN Num = 9
 CASE "o": Num = 12
 CASE ">": Num = 13: x1 = 0: y1 = 10: x2 = 8: y2 = 19
 CASE "<": Num = 14: x1 = 11: y1 = 9: x2 = 19: y2 = 19
 CASE "$"
  IF CoinStat >= 0 AND CoinStat < 4 THEN Num = 15
  IF CoinStat >= 4 AND CoinStat < 8 THEN Num = 16
 CASE CHR$(0): Num = 17
 CASE CHR$(5): Num = 18: x1 = 0: y1 = 4: x2 = 19: y2 = 15
 CASE CHR$(6): Num = 19
 CASE CHR$(7): Num = 20
 CASE CHR$(8): Num = 21
 CASE CHR$(9): Num = 22
 CASE CHR$(10): Num = 23
 CASE CHR$(11): Num = 24
 CASE "a": Num = 25
 CASE "i":
  IF SlimeStat >= 0 AND SlimeStat < 5 THEN Num = 26
  IF SlimeStat >= 5 AND SlimeStat < 10 THEN Num = 27
 CASE CHR$(12):
  dqbrput Layer, x, y, VARSEG(Tile%(s20x20, 28)), VARPTR(Tile%(s20x20, 28)), SawStat, 100: EXIT SUB
 CASE "g":
  IF SlimeStat >= 0 AND SlimeStat < 5 THEN Num = 29
  IF SlimeStat >= 5 AND SlimeStat < 10 THEN Num = 30
 CASE CHR$(13): Num = 31
 CASE CHR$(14): Num = 32
 CASE "|": Num = 33
 CASE "-": Num = 34
 CASE "c": Num = 35: x1 = 0: y1 = 0: x2 = 19: y2 = 19
 CASE CHR$(15):
  IF BeamStat >= 1 AND BeamStat < 2 THEN Num = 36
  IF BeamStat >= 2 AND BeamStat < 3 THEN Num = 37
 CASE CHR$(16):
  IF GnozzStat >= 0 AND GnozzStat < 4 THEN Num = 38
  IF GnozzStat >= 4 AND GnozzStat < 8 THEN Num = 39
 CASE "#":
  IF ZielStat >= 0 AND ZielStat < 4 THEN Num = 40
  IF ZielStat >= 4 AND ZielStat < 8 THEN Num = 41
 CASE "w": IF Layer < 10 THEN dqbput Layer, x, y, VARSEG(WepStat%(s20x20, 1)), VARPTR(WepStat%(s20x20, 1)): EXIT SUB
 CASE ELSE: Num = 0
END SELECT
IF Num > 0 THEN
IF Layer < 10 THEN dqbput Layer, x, y, VARSEG(Tile%(s20x20, Num)), VARPTR(Tile%(s20x20, Num)): EXIT SUB
IF Layer = 10 THEN
IF x1 = 0 AND y1 = 0 AND x2 = 0 AND y2 = 0 THEN EXIT SUB
 x1 = x + x1
 y1 = y + y1
 x2 = x + x2
 y2 = y + y2
 IF x1 < 0 THEN x1 = 0
 IF y1 < 0 THEN y1 = 0
 IF x2 < 0 THEN x2 = 0
 IF y2 < 0 THEN y2 = 0
 IF x1 > 319 THEN x1 = 319
 IF y1 > 199 THEN y1 = 199
 IF x2 > 319 THEN x2 = 319
 IF y2 > 199 THEN y2 = 199
 dqbboxf 10, x1, y1, x2, y2, 15
END IF
END IF
END SUB

'
'Hier werden alle bewegten Objekte dargestellt.
'Smtliche Informationen sind in TYPE-Datenfeldern gespeichert.
'
SUB Put.Objects (xdif, ydif)
dqbclearlayer 5
ObjNum = 0
LxPos = (xdif + 179) \ 20
LyPos = (ydif + 119) \ 20

FOR a = 1 TO MaxVTrans
ObjNum = ObjNum + 1
xp = VTrans(a).x - xdif
yp = VTrans(a).y - ydif
IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
 Put.1Tile 3, xp, yp, CHR$(4)
 Put.1Tile 10, xp, yp, CHR$(4)
END IF
IF Jump = 0 AND (xp + 10 >= 149 AND yp + 10 >= 89 + 20 AND xp + 10 <= 149 + 19 AND yp + 10 <= 89 + 19 + 20) THEN
IF FXD = FALSE THEN
 xxp = (xp + 179) \ 20 * 20
 yyp = (yp + 119) \ 20 * 20
 xdif = xdif + (xp - xxp) - 149
 ydif = ydif + (yp - yyp) - 107 + 2
 Fixed = ObjNum
 FXD = TRUE
END IF
ydif = ydif + VTrans(a).d
 ELSE
 IF FXD = TRUE THEN falled = 0
 FXD = FALSE
END IF
VTrans(a).y = VTrans(a).y + VTrans(a).d
IF VTrans(a).y <= VTrans(a).a THEN
 VTrans(a).d = -VTrans(a).d
 VTrans(a).y = VTrans(a).a + VTrans(a).d
END IF
IF VTrans(a).y >= VTrans(a).s THEN
IF FXD = TRUE THEN ydif = ydif - 2
 VTrans(a).d = -VTrans(a).d
 VTrans(a).y = VTrans(a).s + VTrans(a).d
END IF
NEXT a

FOR a = 1 TO MaxHTrans
ObjNum = ObjNum + 1
xp = HTrans(a).x - xdif
yp = HTrans(a).y - ydif
IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
 Put.1Tile 3, xp, yp, CHR$(5)
 Put.1Tile 10, xp, yp, CHR$(5)
END IF
IF Jump = 0 AND (xp + 10 >= 149 AND yp + 10 >= 89 + 20 AND xp + 10 <= 149 + 19 AND yp + 10 <= 89 + 19 + 20) THEN
IF FXD = FALSE THEN
 xxp = (xp + 179) \ 20 * 20
 yyp = (yp + 119) \ 20 * 20
 xdif = xdif + (xp - xxp) - 149
 ydif = ydif + (yp - yyp) - 107 + 2
 Fixed = ObjNum
 FXD = TRUE
END IF
xdif = xdif + HTrans(a).d
dqbscroll 2, -HTrans(a).d, 0
 ELSE
 IF FXD = TRUE THEN falled = 0
 FXD = FALSE
END IF
HTrans(a).x = HTrans(a).x + HTrans(a).d
IF HTrans(a).x <= HTrans(a).a THEN
 HTrans(a).d = -HTrans(a).d
 HTrans(a).x = HTrans(a).a + HTrans(a).d
END IF
IF HTrans(a).x >= HTrans(a).s THEN
 HTrans(a).d = -HTrans(a).d
 HTrans(a).x = HTrans(a).s + HTrans(a).d
END IF
NEXT a

FOR a = 1 TO MaxHSaws
ObjNum = ObjNum + 1
xp = HSaw(a).x - xdif
yp = HSaw(a).y - ydif
IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
 Put.1Tile 3, xp, yp, CHR$(12)
 IF (xp >= 149 - 15 AND yp >= 89 - 15 AND xp <= 149 + 15 AND yp <= 89 + 15) THEN Health = 0: Put.Status
END IF
HSaw(a).x = HSaw(a).x + HSaw(a).d
IF HSaw(a).x <= HSaw(a).a THEN
 HSaw(a).d = -HSaw(a).d
 HSaw(a).x = HSaw(a).a + HSaw(a).d
END IF
IF HSaw(a).x >= HSaw(a).s THEN
 HSaw(a).d = -HSaw(a).d
 HSaw(a).x = HSaw(a).s + HSaw(a).d
END IF
NEXT a

FOR a = 1 TO MaxHVs
 x1 = HV(a).x1 - xdif
 y1 = HV(a).y1 - ydif
 x2 = HV(a).x2 - xdif
 y2 = HV(a).y2 - ydif
 aaa = FALSE
 IF x1 > -20 AND y1 > -20 AND x1 < 320 AND y1 < 200 THEN aaa = TRUE
 IF x2 > -20 AND y2 > -20 AND x2 < 320 AND y2 < 200 THEN aaa = TRUE
 IF aaa = TRUE AND HVStat = TRUE THEN
  xx1 = x1 + 19: xx3 = x2
  FOR b = 1 TO 4
   yy1 = y1 + 5 + INT(RND * 2) - 1
   xx2 = x1 + (x2 - x1) / 2 + INT(RND * 30) - 15
   yy2 = y2 + 5 + INT(RND * 30) - 15
   dqbline 5, xx1, yy1, xx2, yy2, 51 + b
   dqbline 5, xx2, yy2, x2, y2 + 5 + INT(RND * 2) - 1, 51 + b
   dqbline 10, xx1, yy1, xx2, yy2, 14
   dqbline 10, xx2, yy2, xx3, y2 + 5 + INT(RND * 2) - 1, 14
  NEXT b
 END IF
NEXT a

FOR a = 1 TO MaxBeamers
 x1 = (Beamer(a).x1 - 1) * 20 - xdif + 10
 y1 = (Beamer(a).y1 - 1) * 20 - ydif + 10
 IF (x1 >= 149 AND y1 >= 89 AND x1 <= 149 + 19 AND y1 <= 89 + 19) THEN
 xdif2 = -169 + Beamer(a).x2 * 20
 ydif2 = -109 + Beamer(a).y2 * 20
 Beamto xdif2, ydif2
 EXIT FOR
 END IF
NEXT a

FOR a = 1 TO MaxBotters
xp = Botter(a).x - xdif
yp = Botter(a).y - ydif
LxPos = (Botter(a).x + 9) \ 20 + 1
LyPos = (Botter(a).y + 9) \ 20 + 1

IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
IF Botter(a).d < 0 THEN Num = 6 ELSE Num = 7
 Put.1Tile 5, xp, yp, CHR$(Num)
END IF
 IF Botter(a).d < 0 THEN
  a$ = Map(LxPos - 1, LyPos + 1)
  b$ = Map(LxPos - 1, LyPos)
  IF NOT a$ = " " AND b$ = " " THEN Botter(a).x = Botter(a).x + Botter(a).d ELSE Botter(a).d = -Botter(a).d
 END IF
 IF Botter(a).d > 0 THEN
  a$ = Map(LxPos + 1, LyPos + 1)
  b$ = Map(LxPos + 1, LyPos)
  IF NOT a$ = " " AND b$ = " " THEN Botter(a).x = Botter(a).x + Botter(a).d ELSE Botter(a).d = -Botter(a).d
 END IF

 IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
 'Wenn ein Botter auf der gleichen Hhe wie der Spieler ist, dann
 'evtl. umdrehen und Feuer erffnen
 IF LyPos = (ydif + 119) \ 20 AND Botter(a).pa = 0 THEN
 IF LxPos > (xdif + 179) \ 20 THEN Botter(a).d = -ABS(Botter(a).d) ELSE Botter(a).d = ABS(Botter(a).d)
  Botter(a).pa = Botter(a).d * 5
  Botter(a).py = Botter(a).y
  IF Botter(a).d < 0 THEN Botter(a).px = Botter(a).x - 16 ELSE Botter(a).px = Botter(a).x + 18
  PlaySound "pulsegun"
 END IF
 END IF
NEXT a

'Plasmageschosse
FOR b = 1 TO MaxBotters
IF NOT Botter(b).pa = 0 THEN
 Botter(b).px = Botter(b).px + Botter(b).pa
 IF Botter(b).px - xdif < 0 THEN Botter(b).pa = 0: Botter(b).px = -1000: Botter(b).py = -1000: GOTO DoNextPlasma
 IF Botter(b).px - xdif > 319 THEN Botter(b).pa = 0: Botter(b).px = -1000: Botter(b).py = -1000: GOTO DoNextPlasma
 IF PlasmStat = 8 THEN PlasmStat = 9 ELSE PlasmStat = 8
 IF Botter(b).pa > 0 THEN PlasmStat = PlasmStat + 2: vers = 1 ELSE vers = -1
 Put.1Tile 5, Botter(b).px - xdif, Botter(b).py - ydif, CHR$(PlasmStat)
 Put.1Tile 5, Botter(b).px - xdif - vers * 2, Botter(b).py - ydif, CHR$(PlasmStat)
 Put.1Tile 5, Botter(b).px - xdif - vers * 5, Botter(b).py - ydif, CHR$(PlasmStat)
 IF Botter(b).pa > 0 THEN PlasmStat = PlasmStat - 2
END IF
DoNextPlasma:

 'Checken, ob man getroffen wurde
 xx = Botter(b).px - xdif + 9 - vers * 5
 yy = Botter(b).py - ydif + 9
 IF xx >= 149 AND yy >= 89 AND xx <= 149 + 19 AND yy <= 89 + 19 THEN
  Botter(b).pa = 0
  Botter(b).px = -1000
  Botter(b).py = -1000
  PlaySound "explo1"
  Explo = 9
  Exploxp = 149 + 9
  Exployp = 89 + 9
  ExploHard = 5
  pain = 3
  IF (Botter(b).x + 9) \ 20 + 1 > (xdif + 179) \ 20 THEN cmd$ = "go_left" ELSE cmd$ = "go_right"
  Health = Health - 10
  Put.Status
 END IF

NEXT b

FOR a = 1 TO MaxGnozz

IF NOT Gnozz(a).d = 0 THEN
xp = Gnozz(a).x - xdif
yp = Gnozz(a).y - ydif
LxPos = (Gnozz(a).x + 9) \ 20 + 1
LyPos = (Gnozz(a).y + 9) \ 20 + 1

IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
 Put.1Tile 5, xp, yp, CHR$(16)
 IF yp >= 89 - 15 AND yp <= 89 + 15 AND Shot > 0 AND xp < 159 AND Shotd < 0 THEN ExploGnozz xp, yp, a
 IF yp >= 89 - 15 AND yp <= 89 + 15 AND Shot > 0 AND xp > 159 AND Shotd > 0 THEN ExploGnozz xp, yp, a
END IF
IF xp + 4 >= 149 AND yp + 4 >= 89 AND xp + 14 <= 149 + 19 AND yp + 14 <= 89 + 19 THEN
 pain = 4
 Health = Health - 6
 Put.Status
END IF
 IF Gnozz(a).d < 0 THEN
  a$ = Map(LxPos - 1, LyPos + 1)
  b$ = Map(LxPos - 1, LyPos)
  IF NOT a$ = " " AND b$ = " " THEN Gnozz(a).x = Gnozz(a).x + Gnozz(a).d ELSE Gnozz(a).d = -Gnozz(a).d
 END IF
 IF Gnozz(a).d > 0 THEN
  a$ = Map(LxPos + 1, LyPos + 1)
  b$ = Map(LxPos + 1, LyPos)
  IF NOT a$ = " " AND b$ = " " THEN Gnozz(a).x = Gnozz(a).x + Gnozz(a).d ELSE Gnozz(a).d = -Gnozz(a).d
 END IF
END IF
NEXT a

END SUB

'
'Stellt den Spieler auf dem Bildschirm dar.
'
SUB Put.Player (Walk, Weapon, Dir)
dqbclearlayer 4
IF Weapon = 0 THEN Arm = Walk
IF Ladder = FALSE AND Dir = -1 THEN Walk = Walk + 2
IF Ladder = TRUE THEN Walk = Walk + 4
dqbput 4, 149, 89, VARSEG(You%(s20x20, Walk)), VARPTR(You%(s20x20, Walk))
IF Ladder = FALSE THEN
 IF Weapon = 0 THEN
  Arm = Arm + 10
  IF Dir = -1 THEN Arm = Arm + 2
 ELSE
  Arm = 15
  IF Dir = -1 THEN Arm = Arm + 1
  Arm = Arm + (Weapon - 1) * 2
 END IF
 dqbput 4, 149, 89, VARSEG(You%(s20x20, Arm)), VARPTR(You%(s20x20, Arm))
END IF
'DQBboxf 4, 149 + 4, 89, 149 + 15, 89 + 19, 1
END SUB

'
'Zeigt (wenn erwnscht) die Statusanzeige am unteren Bildschirmrand an,
'und Checkt, ob der Spieler bereits tot ist ;)
'
SUB Put.Status
IF Health <= 0 THEN Death: GotoMenu = 1: EXIT SUB'HAHAHA
IF Status = FALSE THEN EXIT SUB
IF Health > 100 THEN Health = 100
dqbclearlayer 8
FOR x = 0 TO 319 STEP 2
 FOR y = 168 TO 199
  dqbpset 8, x + (y MOD 2), y, 8
 NEXT y
NEXT x
x = 50
dqbput 8, 0, 164, VARSEG(Tile%(s20x20, 15)), VARPTR(Tile%(s20x20, 15))
dqbprint 8, Kurz$(STR$(Coins)), 23, 170, 15
FOR a = 1 TO GCards
 dqbput 8, x, 180, VARSEG(Tile%(s20x20, 8)), VARPTR(Tile%(s20x20, 8))
 x = x + 20
NEXT a
FOR a = 0 TO 5
 DQBgline 8, 317, 192 + a, 215, 192 + a, 49, 40
NEXT a
dqbboxf 8, 216, 194, 216 + Health, 195, DQBpoint(8, 216 + Health, 192) + 72
dqbline 8, 216 + Health, 193, 216 + Health, 196, 8
dqbput 8, 0, 178, VARSEG(Tile%(s20x20, 38)), VARPTR(Tile%(s20x20, 38))
dqbprint 8, Kurz$(STR$(GnozzShot)), 23, 186, 15
dqbprint 8, "Level " + Kurz$(STR$(Level)), 100, 170, 15
dqbprint 8, "F11:", 275, 176, 15
IF Weapon > 0 THEN dqbput 8, 245, 170, VARSEG(WepStat%(s20x20, Weapon)), VARPTR(WepStat%(s20x20, Weapon))
dqbput 8, 297, 170, VARSEG(SndStat%(s20x20, Sounds + 1)), VARPTR(SndStat%(s20x20, Sounds + 1))
END SUB

'
'Zeigt alle Tiles an.
'
SUB Put.Tiles (xdif, ydif)
dqbclearlayer 3
dqbclearlayer 10
FOR xxx = 1 TO Lxmax
 FOR yyy = 1 TO Lymax
  xp = (xxx - 1) * 20 - xdif
  yp = (yyy - 1) * 20 - ydif
  IF Map(xxx, yyy) = "-" AND HVStat = TRUE THEN Map(xxx, yyy) = "|"
  IF Map(xxx, yyy) = "|" AND HVStat = FALSE THEN Map(xxx, yyy) = "-"
  IF xp > -20 AND yp > -20 AND xp < 320 AND yp < 200 THEN
   Put.1Tile 3, xp, yp, Map(xxx, yyy)
   Put.1Tile 10, xp, yp, Map(xxx, yyy)
  END IF
 NEXT yyy
NEXT xxx
END SUB

'
'Speichert den Spielstand (alle wichtigen Variablen und Definitionen) ab.
'
SUB SavePlayer (Player)
f$ = Path$ + "LEVELS\SAVED\player" + Kurz$(STR$(Player)) + ".sav"
nu = FREEFILE
OPEN f$ FOR OUTPUT AS #nu

PRINT #nu, PlayName$
PRINT #nu, STR$(Level)
PRINT #nu, STR$(Lxmax)
PRINT #nu, STR$(Lymax)
PRINT #nu, STR$(xdif)
PRINT #nu, STR$(ydif)
PRINT #nu, STR$(Dir)
PRINT #nu, STR$(Fixed)
PRINT #nu, STR$(Jump)
PRINT #nu, STR$(Fall)
PRINT #nu, STR$(Coins)
PRINT #nu, STR$(Health)
PRINT #nu, STR$(GCards)
PRINT #nu, STR$(GnozzShot)
PRINT #nu, STR$(INT(Walk))
PRINT #nu, STR$(INT(Weapon))
PRINT #nu, STR$(INT(HVStat))

FOR y = 1 TO Lymax
 FOR x = 1 TO Lxmax
  a$ = Map(x, y)
  IF a$ = CHR$(13) OR a$ = CHR$(14) OR a$ = CHR$(15) THEN a$ = " "
  PRINT #nu, a$;
 NEXT x
 PRINT #nu, ""
NEXT y

FOR a = 1 TO MaxVTrans
 x = VTrans(a).x
 y = VTrans(a).y
 s = VTrans(a).s
 d = VTrans(a).d
 anf = VTrans(a).a
 PRINT #1, "obj vtrans -,-,-,"; STR$(x); ","; STR$(y); ","; STR$(s); ","; STR$(d); ","; STR$(anf)
NEXT a
FOR a = 1 TO MaxHTrans
 x = HTrans(a).x
 y = HTrans(a).y
 s = HTrans(a).s
 d = HTrans(a).d
 anf = HTrans(a).a
 PRINT #1, "obj htrans -,-,-,"; STR$(x); ","; STR$(y); ","; STR$(s); ","; STR$(d); ","; STR$(anf)
NEXT a
FOR a = 1 TO MaxHSaws
 x = HSaw(a).x
 y = HSaw(a).y
 s = HSaw(a).s
 d = HSaw(a).d
 anf = HSaw(a).a
 PRINT #1, "obj hsaw -,-,-,"; STR$(x); ","; STR$(y); ","; STR$(s); ","; STR$(d); ","; STR$(anf)
NEXT a
FOR a = 1 TO MaxHVs
 x1 = HV(a).x1 \ 20 + 1
 y1 = HV(a).y1 \ 20 + 1
 x2 = HV(a).x2 \ 20 + 1
 y2 = HV(a).y2 \ 20 + 1
 PRINT #1, "obj hv "; STR$(x1); ","; STR$(y1); ","; STR$(x2); ","; STR$(y2)
NEXT a
FOR a = 1 TO MaxBeamers
 x1 = Beamer(a).x1
 y1 = Beamer(a).y1
 x2 = Beamer(a).x2
 y2 = Beamer(a).y2
 PRINT #1, "obj beamer "; STR$(x1); ","; STR$(y1); ","; STR$(x2); ","; STR$(y2)
NEXT a
FOR a = 1 TO MaxBotters
 x = Botter(a).x \ 20 + 1
 y = Botter(a).y \ 20 + 1
 PRINT #1, "enemy botter "; STR$(x); ","; STR$(y)
NEXT a
FOR a = 1 TO MaxGnozz
 x = Gnozz(a).x \ 20 + 1
 y = Gnozz(a).y \ 20 + 1
 PRINT #1, "enemy gnozz "; STR$(x); ","; STR$(y)
NEXT a

CLOSE #nu
END SUB

SUB SaveSettings
nu = FREEFILE
OPEN Path$ + "settings.ini" FOR OUTPUT AS #nu
PRINT #nu, STR$(Sounds)
PRINT #nu, STR$(Status)
CLOSE #nu
END SUB

'ICC POWERCMD SCRIPT FUNCTION
' SC: Liefert TRUE, wenn der Vorangestellte Befehl der Scriptzeile
'     REC$ vorhanden ist. Die in der Scriptzeile durch Komma abgetrennten
'     Argumente werden in Arg$() bergeben. ArgNum beeinhaltet die
'     Anzahl der vorhandenen Argumente. OuTxt$ beeinhaltet alles,
'     was nach dem Befehl in der Scriptzeile steht (alle Argumente).
'  Copyright(C) 2004, ICC Software
'
FUNCTION SC (L$)
po = INSTR(LCASE$(Rec$), LTRIM$(LCASE$(L$)))
IF po > 1 THEN davor$ = MID$(Rec$, 1, po - 1)
IF INSTR(davor$, CHR$(9)) = FALSE AND NOT Kurz$(davor$) = "" THEN po = FALSE
IF po = FALSE THEN SC = FALSE: EXIT FUNCTION
SC = TRUE
FOR G = 1 TO 10
 Arg$(G) = ""
NEXT G
ArgNum = 0
OuTxt$ = ""
com$ = ""
clin$ = ""
a$ = ""
com$ = MID$(Rec$, po, LEN(L$))
clin$ = MID$(Rec$, po + LEN(L$), LEN(Rec$))
OuTxt$ = clin$

next.val:
ga = 0
DEF SEG = VARSEG(clin$)
s& = SADD(clin$) - 1
ArgNum = ArgNum + 1
FOR G = 1 TO LEN(clin$)
 a = PEEK(s& + G)
 IF a = 34 THEN IF ga = 1 THEN ga = 0 ELSE ga = 1
 IF ga = 0 AND a = 44 THEN clin$ = MID$(clin$, G + 1, LEN(clin$)): GOTO next.val
 Arg$(ArgNum) = Arg$(ArgNum) + CHR$(a)
NEXT G
DEF SEG
END FUNCTION

'
'Scant den Walk-Layer horizontal danach ab, ob unter einem Boden ist oder nicht.
'Auerdem wird gecheckt, ob man in einen HV-Lichtbogen geraten ist.
'
FUNCTION ScanHor (xx, yy)
p = 0
FOR x = xx + 4 TO xx + 15
 Poin = DQBpoint(10, x, yy)
 IF NOT Poin = 0 THEN p = 1
 IF Poin = 14 THEN Health = 0: Put.Status
NEXT x
IF p = 0 THEN ScanHor = TRUE ELSE ScanHor = FALSE
END FUNCTION

'
'Scant den Walk-Layer vertikal danach ab, ob unter einem Boden ist oder nicht.
'Auerdem wird gecheckt, ob man in einen HV-Lichtbogen geraten ist.
'
FUNCTION ScanVert (xx, yy)
p = 0
FOR y = yy TO yy + 19
 Poin = DQBpoint(10, xx, y)
 IF NOT Poin = 0 THEN p = 1
 IF Poin = 14 THEN Health = 0: Put.Status
NEXT y
IF p = 0 THEN ScanVert = TRUE ELSE ScanVert = FALSE
END FUNCTION

'
'Macht einen Screenshot (F2)
'
SUB ScreenShot
dqbgetpal oldpal
a$ = TIME$
a$ = Path$ + "SCRSHOTS\" + LEFT$(a$, 2) + MID$(a$, 4, 2) + RIGHT$(a$, 2) + ".bmp"
IF DQBsaveImage(0, 0, 0, 319, 199, a$, oldpal, bmp) THEN SysErr 4, a$
END SUB

'
'Zeigt die Story an.
'
SUB Story
IF DQBloadFont(Path$ + "graphics\standard.fnt") THEN SysErr 2, Path$ + "graphics\standard.fnt"
ClearLayers
LoadIMG 2, "fbi.bmp", 0, 0, 320, 200
dqbsetpal pal
MachineType 4, 0, 2, "Vor nun fast genau zwei Jahren", 105
MachineType 4, 0, 10, "machte das FBI seltsame Entdeckungen:", 105
MachineType 4, 0, 18, "Terroristen planten einen", 105
MachineType 4, 0, 26, "Nuklearangriff auf den", 105
MachineType 4, 0, 34, "gesamten amerikanischen", 105
MachineType 4, 0, 42, "Kontinent ! Aber selbiges", 105
MachineType 4, 0, 50, "wurde von der Regierung", 105
MachineType 4, 0, 58, "niemals ernstgenommen.", 105
MachineType 4, 0, 76, "Doch vor 6 Monaten wurde", 105
MachineType 4, 0, 84, "der " + CHR$(34) + "Schwachsinn" + CHR$(34), 105
MachineType 4, 0, 92, "Realitt: Nicht nur, dass", 105
MachineType 4, 0, 100, "das FBI herausgefunden", 105
MachineType 4, 0, 108, "hatte, dass mit diesem", 105
MachineType 4, 0, 116, "Angriff nicht einfach mal", 105
MachineType 4, 0, 124, "ganz Amerika weggepustet", 105
MachineType 4, 0, 132, "wrde, sondern auch alles", 105
MachineType 4, 0, 140, "andere organische Leben", 105
MachineType 4, 0, 148, "wre in einer Plutoniumwolke", 105
MachineType 4, 0, 156, "verpufft !!!", 105
DO: LOOP WHILE INKEY$ = ""
dqbsetpal oldpal
ClearLayers
LoadIMG 2, "army.bmp", 0, 0, 320, 200
dqbsetpal pal
MachineType 4, 1, 2, "Doch anhand der zahlreichen", 105
MachineType 4, 1, 10, "Informationen konnte zumindest", 105
MachineType 4, 1, 18, "ein kleiner Teil der Irdischen", 105
MachineType 4, 1, 26, "Bevlkerung mit Hilfe smlicher", 105
MachineType 4, 1, 34, "Militrs gerettet werden -", 105
MachineType 4, 1, 42, "in hyperspacefhigen", 105
MachineType 4, 1, 50, "Stereoshuttles !", 105
MachineType 4, 1, 58, "Nun stellte sich", 105
MachineType 4, 1, 66, "bald die Frage:", 105
MachineType 4, 1, 74, "wohin mit all den", 105
MachineType 4, 1, 82, "Menschen ?", 105
MachineType 4, 1, 90, "Der Mars schien eine", 105
MachineType 4, 1, 98, "geeignete Lsung zu", 105
MachineType 4, 1, 106, "sein, man knnte", 105
MachineType 4, 1, 114, "eine knstliche", 105
MachineType 4, 1, 122, "Athmosphre schaffen.", 105
DoLayer
DO: LOOP WHILE INKEY$ = ""
ClearLayers
LoadIMG 2, "fbi.bmp", 0, 0, 320, 200
dqbsetpal pal
MachineType 4, 0, 2, "Doch bald schon stellte sich", 105
MachineType 4, 0, 10, "heraus, dass der Mars nicht nur", 105
MachineType 4, 0, 18, "ein Objekt der Begierde fr die", 105
MachineType 4, 0, 26, "Menschen ist -", 105
MachineType 4, 0, 34, "Nein, auch gewisse Bewohner", 105
MachineType 4, 0, 42, "eines anderen Planeten", 105
MachineType 4, 0, 50, "hatten Interesse an einer", 105
MachineType 4, 0, 58, "Inbesitznahme des Mars..", 105
MachineType 4, 0, 76, "Selbstverstndlich wre", 105
MachineType 4, 0, 84, "es unter diesen", 105
MachineType 4, 0, 92, "Bedingungen unmglich,", 105
MachineType 4, 0, 100, "dass die Menschen noch", 105
MachineType 4, 0, 108, "irgendeine Chance auf einen", 105
MachineType 4, 0, 116, "Heimatplaneten htten !", 105
MachineType 4, 0, 124, "Also hat die vorlufige", 105
MachineType 4, 0, 132, "Regierung ihren besten Mann", 105
MachineType 4, 0, 140, "(das bist du) losgeschickt,", 105
MachineType 4, 0, 148, "um den Mars zu bereinigen...", 105
MachineType 4, 0, 156, " - Viel Glck !", 105
DO: LOOP WHILE INKEY$ = ""

dqbfadeto 0, 0, 0
ClearLayers
dqbsetpal oldpal
FOR a = 1 TO 15: a$ = INKEY$: NEXT a
IF DQBloadFont(Path$ + "graphics\hitech.fnt") THEN SysErr 2, Path$ + "graphics\hitech.fnt"
END SUB

REM $DYNAMIC
'
'Gibt Informationen zu Systemfehlern aus.
'
SUB SysErr (Num, t2$)
dqbclose
CLS
COLOR 4
PRINT "MARSBASE v1.00 :: ERROR #"; Kurz$(STR$(Num))
PRINT
SELECT CASE Num
 CASE 1: t1$ = "DQB konnte nicht initialisiert werden !"
 CASE 2: t1$ = "Schriftdatei nicht gefunden !"
 CASE 3: t1$ = "Bilddatei konnte nicht geladen werden !"
 CASE 4: t1$ = "Fehler beim Erstellen des Screenshots !"
 CASE 5: t1$ = "Fehler beim Initialisieren der Sounds !"
END SELECT
PRINT t1$
COLOR 7
PRINT t2$
PRINT DQBerror$
SYSTEM
END SUB

REM $STATIC
'
'Befrdert einen ins nchste Level, zeigt den Gewinnerbildschirm.
'
SUB WarpToNextLevel
PlaySound "beam"
dqbclearlayer 5
DO
Put.Tiles xdif, ydif
FOR x = -320 TO 320 STEP 2
dqbline 3, x, 0, 320 + x, 320, ABS(x) / 20 + 16
dqbline 3, 320 + x, 0, x, 320, ABS(x) / 20 + 16
NEXT x
dqbclearlayer 4
Fra2 = Fra2 + 1
IF Fra2 > 4 THEN Fra2 = 1
dqbput 4, 149, 89, VARSEG(You%(s20x20, 6 + Fra2)), VARPTR(You%(s20x20, 6 + Fra2))
DoLayer

ydif = ydif - 40
IF ydif < -700 THEN EXIT DO
LOOP
dqbgetpal oldpal
dqbfadeto 63, 63, 63
dqbclearlayer 0

f$ = Path$ + "LEVELS\SAVED\player" + Kurz$(STR$(Player)) + ".sav"
G$ = Path$ + "LEVELS\CLEAN\map" + Kurz$(STR$(Level + 1)) + ".lev"
nu = FREEFILE: OPEN G$ FOR BINARY AS #nu: f = LOF(nu): CLOSE #nu
IF f > 0 THEN
nu = FREEFILE: OPEN f$ FOR OUTPUT AS #nu
nu2 = FREEFILE: OPEN G$ FOR INPUT AS #nu2
DO WHILE NOT EOF(nu2): LINE INPUT #nu2, doof$: PRINT #nu, doof$: LOOP
CLOSE #nu, #nu2
LoadIMG 0, "warp.bmp", 0, 0, 320, 200
ELSE
KILL G$
LoadIMG 0, "finished.bmp", 0, 0, 320, 200
END IF

pal = CHR$(63) + CHR$(63) + CHR$(63) + RIGHT$(pal, 765)
dqbsetpal pal

IF f = 0 THEN
dqbremovekeyboard
FOR a = 1 TO 15: doof$ = INKEY$: NEXT a
DO: LOOP WHILE INKEY$ = ""
dqbinstallkeyboard
ELSE
SLEEP 1
END IF

dqbfadeto 0, 0, 0
ClearLayers
dqbsetpal oldpal
END SUB

